/*
TASK: trav
LANG: C
*/
#include <stdio.h>

#define MAXN 16
#define MAXM 64

int t[MAXN][MAXM];
int fact[MAXN];
int perm[MAXN],bmas[MAXN];
int n,m;
int times[MAXN][MAXM];
int best = 2000000000;

int max(int a,int b) { return (a>b)?a:b; }

void update(int index) {
int i,j;
int sum = 0;
int ind;
     for (i=index;i<=n;i++) {
         ind = perm[i];
         times[i][0] = 0;
         for (j=1;j<=m;j++)
             times[i][j] = max(times[i-1][j],times[i][j-1]+t[ind][j]);
     }
     for (i=1;i<=n;i++)
         sum+=times[i][m];
     if (sum<best) {
         best = sum;
         memcpy(bmas,perm,sizeof(bmas));
     }
}

int main () {
int i,j,k,l,best,temp;
//    freopen ( "trav.in" , "r", stdin);
    scanf("%d%d",&n,&m);
    for (i=1;i<=n;i++)
        for (j=1;j<=m;j++)
            scanf("%d",&t[i][j]);
    fact[0] = 1;
    for (i=1;i<=9;i++)
        fact[i] = fact[i-1]*i;
    for (i=1;i<=n;i++)
        perm[i] = i;
    memset(times,0,sizeof(times));
    update(1);
    for (i=1;i<fact[n];i++) {
        for (j=n-1;j>=1;j--)
            if (perm[j]<perm[j+1])
               break;
        best = j+1;
        for (k=j+2;k<=n;k++)
            if (perm[k]>perm[j] && perm[k]<perm[best])
               best = k;
        temp = perm[j];
        perm[j] = perm[best];
        perm[best] = temp;
        for (k=j+1,l=0;k<=n && (k<n-l);k++,l++) {
            temp = perm[k];
            perm[k] = perm[n-l];
            perm[n-l] = temp;
        }
        update(j);
/*        for (j=1;j<=n;j++)
            printf("%d ",perm[j]);
        printf("\n");*/
    }
    for (i=1;i<=n;i++)
        printf("%d%c",bmas[i],(i==n)?'\n':' ');
    return 0;
}
