/*
TASK:points
LANG:C
*/

#include <stdio.h>

//#define DEBUG_ME

#define IN      "points.in"
#define MAX     1100

long n, inside, s, outside;
long x[MAX], y[MAX];

long gcd(long a, long b)
{
   long r;

   if(a==0) return b;
   if(b==0) return a;

   if(a>b) return gcd(b, a);

   r=a%b;
   while(r)
   {
      a=b;
      b=r;
      r=a%b;
   }

   return b;
}

int main()
{
   long i, diffx, diffy;

#ifdef DEBUG_ME
   freopen(IN, "r", stdin);
#endif

   scanf("%ld", &n);

   for(i=0; i<n; i++)
      scanf("%ld%ld", x+i, y+i);
   x[n]=x[0];
   y[n]=y[0];

#ifdef DEBUG_ME
   fclose(stdin);
#endif

   for(i=0; i<n; i++)
   {
      diffx=abs(x[i]-x[i+1]);
      diffy=abs(y[i]-y[i+1]);

      outside+=gcd(diffx, diffy);
   }

   for(i=0; i<n; i++)
   {
      s+=(x[i]-x[i+1])*(y[i]+y[i+1]);
   }

   if(s<0) s=-s;

   printf("%ld\n", (long)(s/(double)2+(double)1-outside/(double)2+(double)outside));


   return 0;
}

