/*
TASK:points
LANG:C++
*/
# include <stdio.h>
# include <stdlib.h>
# include <limits.h>
# define MAXN 1024
# define e 1e-10

struct point{
	int x,y;
};
point *data;
point buf[MAXN];

int n, minx=INT_MAX, maxx=INT_MIN, br;
void readf() {
//	freopen("points.in","r",stdin);
    scanf("%d",&n);
    for ( int i=1 ; i<=n ; i++ ) {
    	scanf("%d %d",&buf[i].x,&buf[i].y);
        if ( buf[i].x<minx )
        	minx = buf[i].x;
        if ( buf[i].x>maxx )
        	maxx= buf[i].x;
    }
    buf[n+1].x = buf[1].x;
    buf[n+1].y = buf[1].y;
    data = buf+1;
    data[-1].x = buf[n].x;
    data[-1].y = buf[n].y;
}
double cross(int k, int x) {
	if ( ( data[k].x<x && data[k+1].x>x )||( data[k].x>x && data[k+1].x<x ) ) {
    	if ( data[k].y<data[k+1].y )
	        return ((double)abs(data[k].y-data[k+1].y)/(double)abs(data[k].x-data[k+1].x))
       	 		*(abs(x-data[k].x))+data[k].y;
        else {
	        return ((double)abs(data[k].y-data[k+1].y)/(double)abs(data[k].x-data[k+1].x))
       	 		*(abs(x-data[k+1].x))+data[k+1].y;
        }
    } else {
    	return INT_MAX;
    }
}
int add(double a, double b) {
	double buf;
	if ( a>b ) {
    	buf = a;
        a = b;
        b = buf;
    }
    if ( a-((int)a)<e && a-((int)a)>-e ) {
    	a = (int)a;
    } else {
    	a = (int)(a+0.5);
    }
    if ( b-((int)b+1)<e && b-((int)b+1)>-e ) {
    	b = (int)b+1;
    } else {
    	b = (int)(b);
    }
    return ((int)b-(int)a+1);

}
void work() {
	int p=0;
    double a,b,c;
    int p1,p2;
    for ( int i=minx ; i<=maxx ; i++ ) {
    	p=0;
    	for ( int j=0 ; j<n ; j++ ) {
            if ( data[j].x==i ) {
            	if ( (i-data[j-1].x)*(i-data[j+1].x)<=0 ) {
            		if ( p==0 ) {
            			p = 1;
	            		a = data[j].y;
    	            } else {
        	        	p = 0;
            	        b = data[j].y;
	                    br+=add(a,b);
    	            }
                } else {
                	if ( p==0 )
                    	br++;
                }
            }
            c = cross(j,i);
            if ( c!=INT_MAX ) {
            	if ( p==0 ) {
                	p = 1;
                    a = c;
                } else {
                	p = 0;
                    b = c;
                    br+=add(a,b);
                }
            }

        }
    }

}
int main() {
	readf();
    work();
    printf("%d\n",br);
    return 0;
}
