/*
TASK: string
LANG: C
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#define MAXN (100100)
#define MAXL (16)

char a[MAXN][MAXL];
int l[MAXN];
int n, ans, ansi;
int ix[MAXN];

int min (int a, int b)  {
  return a < b ? a : b;
}

int scmp (const void *ee1, const void *ee2)  {
  int i, m, e1, e2;

  e1 = *(int*)ee1;
  e2 = *(int*)ee2;

  if (l[e1] != l[e2])
    return l[e1] - l[e2];

  m = l[e1];

  for (i = 1; i <= m; ++i)  {
    if (a[e1][i] < a[e2][i])
      return -1;
    if (a[e1][i] > a[e2][i])
      return +1;
  }

  return 0;
}

void init ()  {
  int i;

//freopen ("string.in" , "r", stdin );
//freopen ("string.out", "w", stdout);

  scanf ("%d", &n);

  for (i = 1; i <= n; ++i)  {
    scanf ("%s", a[i] + 1);
    ix[i] = i;
    l[i] = strlen (a[i] + 1);
  }
  strcat (a[i + 1] + 1, "ZZZZZZZZZZZ");
  ix[i + 1] = i + 1;

  qsort (ix + 1, n, sizeof(int), scmp);
}

void think ()  {
  int i, t, mx;

  ans = INT_MAX;
  ansi = INT_MAX;
  mx = ix[1];
  t = 1;

  for (i = 2; i <= n + 1; ++i)  {
    if (scmp (&ix[i - 1], &ix[i]) == 0)  {
      ++t;
      if (mx > ix[i])
        mx = ix[i];
    }
    else  {
      if (ans > t)  {
        ans = t;
        ansi = mx;
      }
      if (ans == t)  {
        if (ansi > mx)
          ansi = mx;
      }
      t = 1;
      mx = ix[i];
    }
  }
}

void print ()  {
  int i;

/*
  printf ("%d\n", n);

  for (i = 1; i <= n; ++i)
    printf ("%s\n", a[ix[i]] + 1);
*/

  printf ("%s\n", a[ansi] + 1);
}

int main ()  {
  init ();
  think ();
  print ();

  return 0;
}

