/*
TASK: trav
LANG: C
*/

#include <stdio.h>

#define N 16
#define M 64

int t[N][M];
int n, m;

int ct[M];
int c[N];
int b[N];
int bt = 256*64*256*16;

void try() {
        int i, j;
        int pt;
        int sum;

        for (i = 0; i <= m; i++)
                ct[i] = 0;

        sum = 0;
        for (i = 1; i <= n; i++) {
                pt = 0;
                for (j = 1; j <= m; j++) {
                        if (pt + t[c[i]][j] > ct[j]) {
                                pt += t[c[i]][j];
                                ct[j] = pt;
                        } else
                                pt = ct[j];
                }
                sum += ct[m];
        }

        if (sum < bt) {
                bt = sum;
                for (i = 1; i <= n; i++)
                        b[i] = c[i];
        }
}

void solve() {
        int m;
        int i, j;
        int s;

        for (i = 1; i <= n; i++)
                c[i] = i;

        while (1) {
                try();
                for (i = n-1; i > 0; i--)
                        if (c[i] < c[i+1])
                                break;
                if (i == 0)
                        break;

                m = i+1;
                for (j = i+1; j <= n; j++)
                        if ((c[j] > c[i]) && (c[j] < c[m]))
                                m = j;

                s = c[i];
                c[i] = c[m];
                c[m] = s;
                for (j = 1; i+j < n-j+1; j++) {
                        s = c[i+j];
                        c[i+j] = c[n-j+1];
                        c[n-j+1] = s;
                }
        }

        printf("%d", b[1]);
        for (i = 2; i <= n; i++)
                printf(" %d", b[i]);
        printf("\n");
}

int main() {
        int i, j;

        //freopen("trav.in", "r", stdin);
        scanf("%d%d", &n, &m);

        for (i = 1; i <= n; i++)
                for (j = 1; j <= m; j++)
                        scanf("%d", &t[i][j]);

        solve();

        return 0;
}
