/*
TASK:string
LANG:C
*/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define MAXS 110000

typedef struct {
        char s[12];
        char len;
        int id;
} TS;

TS m[MAXS];

int cmp(const void *a, const void *b) {
    if (((TS *)a)->len==((TS *)b)->len)
       return strcmp(((TS *)a)->s,((TS *)b)->s);
    else
       return (((TS *)a)->len-((TS *)b)->len);
}

int main () {
int i,n,cur_count,cur_id,best_count=2000000000,best_id;
//    freopen ( "string.in" , "r" , stdin);
    scanf("%d\n",&n);
    for (i=0;i<n;i++) {
        scanf("%s\n",m[i].s);
        m[i].id = i;
        m[i].len = strlen(m[i].s);
    }
    qsort(m,n,sizeof(TS),cmp);
    cur_count = 1;
    cur_id = m[0].id;
    for (i=1;i<n;i++)
        if (m[i].len==m[i-1].len && strcmp(m[i].s,m[i-1].s)==0) {
           if (m[i].id<cur_id)
              cur_id = m[i].id;
           cur_count++;
        } else {
           if (cur_count<best_count || (cur_count==best_count && cur_id<best_id)) {
              best_count = cur_count;
              best_id = cur_id;
           }
           cur_count = 1;
           cur_id = m[i].id;
        }
    if (cur_count<best_count || (cur_count==best_count && cur_id<best_id)) {
       best_count = cur_count;
       best_id = cur_id;
    }
    for (i=0;i<n;i++)
        if (m[i].id==best_id) {
           printf("%s\n",m[i].s);
           return 0;
        }
    return 0;
}
