/*
TASK: TRAV
LANG: C
*/

#include <stdio.h>

#define MAXN            15
#define MAXM            55

#define INF             2000000000

int n,m;
int mas[MAXN][MAXN];
int used[MAXN];
int ans[MAXN];
int timet[MAXN];
int glmin;
int glans[MAXN];
//int prec[MAXM][MAXN];
int allprec[MAXM];

void input()
{
  int i,i2;

  scanf("%d %d",&n,&m);

  for(i=1;i<=n;i++)
    for(i2=1;i2<=m;i2++)
    {
      scanf("%d",&mas[i][i2]);
    }
}

void Check()
{
  int i,i2;
  int latest;
  int sum;

  for(i=1;i<=n;i++)
    timet[i] = 0;

  for(i=1;i<=m;i++)
  {
    latest = 0;
    sum = 0;

    for(i2=1;i2<=n;i2++)
    {
      if((timet[ans[i2]]+mas[ans[i2]][i])>latest)
        latest = timet[ans[i2]]+mas[ans[i2]][i];

      timet[ans[i2]] = latest;
      sum += latest;
      if(sum>glmin)
        return;
    }

    if(sum+allprec[i+1] >= glmin)
      return;
  }

  sum = 0;

  for(i=1;i<=n;i++)
    sum += timet[i];

  if(sum<glmin)
  {
    glmin = sum;
    for(i=1;i<=n;i++)
      glans[i] = ans[i];
  }
}

void rec(int l)
{
  int i;

  if(l>n)
  {
    Check();
    return;
  }

  for(i=1;i<=n;i++)
    if(!used[i])
    {
      used[i] = 1;
      ans[l] = i;
      rec(l+1);
      used[i] = 0;
    }
}

void solve()
{
  int i,i2;

/*  for(i=1;i<=n;i++)
    prec[m+1][i] = 0;

  for(i=m;i>0;i--)
    for(i2=1;i2<=n;i2++)
      prec[i][i2] = prec[i+1][i2]+mas[i2][i];*/

  allprec[m+1] = 0;

  for(i=m;i>0;i--)
  {
    allprec[i] = allprec[i+1];
    for(i2=1;i2<=n;i2++)
    {
      allprec[i] += mas[i2][i];
    }
  }


  for(i=0;i<=n;i++)
  {
    used[i] = 0;
  }

  glmin = INF;

  rec(1);
}

void output()
{
  int i;

  for(i=1;i<n;i++)
    printf("%d ",glans[i]);

  printf("%d\n",glans[n]);
}

int main()
{
//  freopen("trav.inp","r",stdin);

  input();
  solve();
  output();

  return 0;
}

